> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.yunojuno.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.yunojuno.com/_mcp/server.

# Retrieve a contract's timesheets

GET https://api.yunojuno.com/contracts/{contract_id}/timesheets/

Retrieve approved timesheets for a contract.

Return the approved timesheets for a contract, ordered by start date. Only final-state timesheets are exposed via the public API for now (APPROVED or ZERO_TIME).

Reference: https://docs.yunojuno.com/client-api/contracts/timesheets-retrieve

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `contract_id` (string, required)

## Response

### 200

- `data` (list of Timesheet, required)

## Errors

### 401 Unauthorized Error

The access token is missing or invalid.

- `error` (Error, required)

### 404 Not Found Error

No contract with this ID belongs to the client account the access token was issued for.

- `error` (Error, required)

## Types

### Timesheet

The timesheet object. This object represents the work or time submitted in a given time window for a particular contract by a freelancer.

- `timesheet_id` (string, required)
- `state` (string, required)
- `start_date` (string, required)
- `end_date` (string, required)
- `entries` (list of TimesheetEntriesItems, required) — List of timesheet entries. Each entry will be serialized based on its kind (STANDARD, OVERTIME, EXPENSE, or ADJUSTMENT).
- `yunojuno_po_number` (string, required)

### Error

- `code` (string, required) — A machine-readable code, such as AUTH_TOKEN_INVALID.
- `message` (string, required) — A description you can show to a person.
- `details` (list of ErrorDetail, optional) — Present on validation errors, one entry per failing field.
- `sentry_id` (string, optional) — Present on server errors. Quote it when you contact support.

### TimesheetEntriesItems

### ErrorDetail

One field-level problem, listed on a validation error.

- `code` (string, required) — A machine-readable code, such as VALIDATION_REQUIRED.
- `field` (string, required) — The input field at fault. Nested fields and list indexes are dot-separated, such as data.1.contract.
- `message` (string, required) — What is wrong with the field.

### StandardTimesheetEntry

- `date` (string, required)
- `quantity_completed` (string, required) — The quantity of work completed for the given day in minutes.
- `kind` (string, optional, default: STANDARD)
- `note` (string, optional, default: )
- `project` (ProjectReference, optional) — Project lookup reference for timesheet entries. Provide either `id` OR `external_id` to identify the project. Exactly one identifier must be provided.
- `client_purchase_order` (ClientPurchaseOrderReference, optional)

### OvertimeTimesheetEntry

- `date` (string, required)
- `quantity_completed` (string, required) — The quantity of work completed for the given day in minutes.
- `kind` (string, optional, default: OVERTIME)
- `note` (string, optional, default: )
- `project` (ProjectReference, optional) — Project lookup reference for timesheet entries. Provide either `id` OR `external_id` to identify the project. Exactly one identifier must be provided.
- `client_purchase_order` (ClientPurchaseOrderReference, optional)

### AdjustmentTimesheetEntry

- `date` (string, required)
- `unit_cost` (string, required)
- `note` (string, required)
- `kind` (string, optional, default: ADJUSTMENT)
- `project` (ProjectReference, optional) — Project lookup reference for timesheet entries. Provide either `id` OR `external_id` to identify the project. Exactly one identifier must be provided.
- `client_purchase_order` (ClientPurchaseOrderReference, optional)

### ExpenseTimesheetEntry

- `date` (string, required)
- `unit_cost` (string, required)
- `note` (string, required)
- `kind` (string, optional, default: EXPENSE)
- `project` (ProjectReference, optional) — Project lookup reference for timesheet entries. Provide either `id` OR `external_id` to identify the project. Exactly one identifier must be provided.
- `client_purchase_order` (ClientPurchaseOrderReference, optional)

### ProjectReference

Project lookup reference for timesheet entries. Provide either `id` OR `external_id` to identify the project. Exactly one identifier must be provided.

- `id` (string, optional) — The YunoJuno project ID (e.g., 'prj_abc123').
- `external_id` (string, optional) — Your external project identifier.

### ClientPurchaseOrderReference

- `reference` (string, required)

## Examples

**Response**

```json
{
  "data": [
    {
      "timesheet_id": "string",
      "state": "string",
      "start_date": "2023-01-15",
      "end_date": "2023-01-15",
      "entries": [
        {
          "date": "2023-01-15",
          "kind": "STANDARD",
          "quantity_completed": "string",
          "note": "",
          "project": {
            "id": "string",
            "external_id": "string"
          },
          "client_purchase_order": {
            "reference": "string"
          }
        }
      ],
      "yunojuno_po_number": "string"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.yunojuno.com/contracts/contract_id/timesheets/"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.yunojuno.com/contracts/contract_id/timesheets/';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.yunojuno.com/contracts/contract_id/timesheets/"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.yunojuno.com/contracts/contract_id/timesheets/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.yunojuno.com/contracts/contract_id/timesheets/")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.yunojuno.com/contracts/contract_id/timesheets/', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.yunojuno.com/contracts/contract_id/timesheets/");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.yunojuno.com/contracts/contract_id/timesheets/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```